#include <limits.h>

#include "BuscaLocal.h"

tpCusto Busca2Opt( tpGrafo Grafo   ,
                   tpCusto Custo   ,
                   tpNo*   Solucao  ) {

   tpNo    i                   ;
   tpNo    j                   ;
   tpNo    tempo               ;
   tpCusto melhorCusto = Custo ;
   int    otimoLocal          ;

   do {
      otimoLocal = 1 ;
      i = 0 ;
      do {
         j = Solucao[ Solucao [ i ] ] ;
         do {
            // Avaliar novo vizinho
            if ( ( PESO( Grafo, i, j ) < INT_MAX ) &&
                 ( PESO( Grafo, Solucao[ i ], Solucao[ j ] ) < INT_MAX ) ) {
               Custo = melhorCusto ;
               Custo -= PESO( Grafo, i, Solucao[ i ] ) ;
               Custo -= PESO( Grafo, j, Solucao[ j ] ) ;
               Custo += PESO( Grafo, i, j ) ;
               Custo += PESO( Grafo, Solucao[ i ], Solucao[ j ] ) ;
               if ( Custo < melhorCusto ) {
                  otimoLocal = 0 ;
                  melhorCusto = Custo ;
                  // Gera vizinho 2-0pt
                  do {

                     tempo = Solucao[ Solucao[ j ] ] ;
                     Solucao[ Solucao[ j ] ] = Solucao[ i ] ;
                     Solucao[ i ] = Solucao[ j ] ;
                     Solucao[ j ] = tempo ;

                  } while ( Solucao[ j ] != i ) ;
               }
            }

            j = Solucao[ j ] ;

            // S ocorre essa situao uma nica vez. Tira esse IF daqui!
            if ( (i == 0) && ( Solucao[ j ] == 0 ) ) break ;

         } while ( otimoLocal && ( j != 0 ) ) ;

         i = Solucao[ i ] ;
      } while ( otimoLocal && ( Solucao[ Solucao[ i ] ] != 0 ) ) ;

   } while ( !otimoLocal ) ;

   return melhorCusto ;

} /* Busca2Opt */


tpCusto Busca2OptTo3Opt( tpGrafo Grafo   ,
                         tpCusto Custo   ,
                         tpNo*   Solucao  ) {

   tpNo    i           ;
   tpNo    j           ;
   tpNo    k           ;
   tpNo    c           ;
   tpNo    tempo       ;
   tpCusto melhorCusto ;
   int    otimoLocal  ;

   do {
      otimoLocal = 1 ;
      
      melhorCusto = Busca2Opt( Grafo, Custo, Solucao ) ;

      i = 0 ;
      do {
         j = Solucao[ Solucao [ i ] ] ;
         do {
            k = Solucao[ Solucao [ j ] ] ;
            do {
               for ( c = 0 ; c < 4 ; c++ ) {
                  switch ( c ) {
                  case 0:
                     if ( ( PESO( Grafo, i, Solucao[ j ] ) < INT_MAX ) &&
                          ( PESO( Grafo, k, Solucao[ i ] ) < INT_MAX ) &&
                          ( PESO( Grafo, j, Solucao[ k ] ) < INT_MAX ) ) {
                        Custo = melhorCusto ;
                        Custo -= PESO( Grafo, i, Solucao[ i ] ) ;
                        Custo -= PESO( Grafo, j, Solucao[ j ] ) ;
                        Custo -= PESO( Grafo, k, Solucao[ k ] ) ;
                        Custo += PESO( Grafo, i, Solucao[ j ] ) ;
                        Custo += PESO( Grafo, k, Solucao[ i ] ) ;
                        Custo += PESO( Grafo, j, Solucao[ k ] ) ;
                        if ( Custo < melhorCusto ) {
                           otimoLocal = 0 ;
                           melhorCusto = Custo ;
                           // Gera o primeiro vizinho 3-0pt
                           tempo = Solucao[ i ] ;
                           Solucao[ i ] = Solucao[ j ] ;
                           Solucao[ j ] = Solucao[ k ] ;
                           Solucao[ k ] = tempo ;
                        }
                     }
                     break;
                  case 1:
                     if ( ( PESO( Grafo, i, Solucao[ j ] ) < INT_MAX ) &&
                          ( PESO( Grafo, k, j ) < INT_MAX ) &&
                          ( PESO( Grafo, Solucao[ i ], Solucao[ k ] ) < INT_MAX ) ) {
                        Custo = melhorCusto ;
                        Custo -= PESO( Grafo, i, Solucao[ i ] ) ;
                        Custo -= PESO( Grafo, j, Solucao[ j ] ) ;
                        Custo -= PESO( Grafo, k, Solucao[ k ] ) ;
                        Custo += PESO( Grafo, i, k ) ;
                        Custo += PESO( Grafo, Solucao[ j ], Solucao[ i ] ) ;
                        Custo += PESO( Grafo, j, Solucao[ k ] ) ;
                        if ( Custo < melhorCusto ) {
                           otimoLocal = 0 ;
                           melhorCusto = Custo ;
                           // Gera o segundo vizinho 3-0pt
                           do {

                              tempo = Solucao[ Solucao[ j ] ] ;
                              Solucao[ Solucao[ j ] ] = Solucao[ i ] ;
                              Solucao[ i ] = Solucao[ j ] ;
                              Solucao[ j ] = tempo ;

                           } while ( Solucao[ i ] != k ) ;
                        }
                     }
                     break;
                  case 2:
                     if ( ( PESO( Grafo, i, Solucao[ j ] ) < INT_MAX ) &&
                          ( PESO( Grafo, k, j ) < INT_MAX ) &&
                          ( PESO( Grafo, Solucao[ i ], Solucao[ k ] ) < INT_MAX ) ) {
                        Custo = melhorCusto ;
                        Custo -= PESO( Grafo, i, Solucao[ i ] ) ;
                        Custo -= PESO( Grafo, j, Solucao[ j ] ) ;
                        Custo -= PESO( Grafo, k, Solucao[ k ] ) ;
                        Custo += PESO( Grafo, i, Solucao[ j ] ) ;
                        Custo += PESO( Grafo, k, j ) ;
                        Custo += PESO( Grafo, Solucao[ i ], Solucao[ k ] ) ;
                        if ( Custo < melhorCusto ) {
                           otimoLocal = 0 ;
                           melhorCusto = Custo ;
                           // Gera o terceiro vizinho 3-0pt
                           do {

                              tempo = Solucao[ Solucao[ i ] ] ;
                              Solucao[ Solucao[ i ] ] = Solucao[ k ] ;
                              Solucao[ k ] = Solucao[ i ] ;
                              Solucao[ i ] = tempo ;

                           } while ( Solucao[ k ] != j ) ;
                        }
                     }
                     break;
                  case 3:
                     if ( ( PESO( Grafo, k, Solucao[ i ] ) < INT_MAX ) &&
                          ( PESO( Grafo, j, i ) < INT_MAX ) &&
                          ( PESO( Grafo, Solucao[ k ], Solucao[ j ] ) < INT_MAX ) ) {
                        Custo = melhorCusto ;
                        Custo -= PESO( Grafo, i, Solucao[ i ] ) ;
                        Custo -= PESO( Grafo, j, Solucao[ j ] ) ;
                        Custo -= PESO( Grafo, k, Solucao[ k ] ) ;
                        Custo += PESO( Grafo, k, Solucao[ i ] ) ;
                        Custo += PESO( Grafo, j, i ) ;
                        Custo += PESO( Grafo, Solucao[ k ], Solucao[ j ] ) ;
                        if ( Custo < melhorCusto ) {
                           otimoLocal = 0 ;
                           melhorCusto = Custo ;
                           // Gera o quarto vizinho 3-0pt
                           do {

                              tempo = Solucao[ Solucao[ k ] ] ;
                              Solucao[ Solucao[ k ] ] = Solucao[ j ] ;
                              Solucao[ j ] = Solucao[ k ] ;
                              Solucao[ k ] = tempo ;

                           } while ( Solucao[ j ] != i ) ;
                        }
                     }
                     break;
                  }
                  if ( !otimoLocal ) break ;
               }
               k = Solucao[ k ] ;

               // S ocorre essa situao uma nica vez. Tira esse IF daqui!
               if ( (i == 0) && ( Solucao[ k ] == 0 ) ) break ;

            } while ( otimoLocal && ( k != 0 ) ) ;
            j = Solucao[ j ] ;
         } while ( otimoLocal && ( Solucao[ Solucao[ j ] ] != 0 ) ) ;
         i = Solucao[ i ] ;
      } while ( otimoLocal && ( Solucao[ Solucao[ Solucao[ Solucao[ i ] ] ] ] != 0 ) ) ;

      // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      // !!! CUIDADO - Quanto i == 0 e Solucao[ k ] == 0 no  vlido !!!
      // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   } while ( !otimoLocal ) ;

   return melhorCusto ;

} /* Busca2OptTo3Opt */
