#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <limits.h>

#include "Leitor.h"
#include "GRASP.h"

#define SZ_FORMATO "FORMATO: travelingsalesman aleatorio | euclidiano | instancia nome_arq otimo\n"


int main( int    argc ,
          char** argv  ) {
   
   if ( argc < 2
     || argc == 3
     || argc > 4
     || ( argc == 2
       && strcmp( argv[ 1 ], "aleatorio" ) != 0
       && strcmp( argv[ 1 ], "euclidiano" ) != 0 )
     || ( argc == 4
       && strcmp( argv[ 1 ], "instancia" ) != 0 ) ) {

      printf( SZ_FORMATO ) ;
      return 0 ;
   } /* if */

   srand( time( NULL ) ) ;
   
   if ( argc == 2 ) {

      AnalisarCons( VizinhoMaisProximo, 1000, argv[ 1 ], "\n\nVizinho Mais Proximo\n" ) ;
      AnalisarCons( InsercaoMaisProxima, 1000, argv[ 1 ], "\n\nInsercao Mais Proxima\n" ) ;
      AnalisarCons( InsercaoMaisDistante, 1000, argv[ 1 ], "\n\nInsercao Mais Distante\n" ) ;
      AnalisarCons( InsercaoMaisBarata, 1000, argv[ 1 ], "\n\nInsercao Mais Barata\n" ) ;
   
      AnalisarGRASP( VizinhoMaisProximo, Busca2Opt, argv[ 1 ], "\n\nVizinho Mais Proximo\n", "2-opt\n" ) ;  
      AnalisarGRASP( VizinhoMaisProximo, Busca2OptTo3Opt, argv[ 1 ], "\n\nVizinho Mais Proximo\n", "2-opt a 3-opt\n" ) ;  
   
      AnalisarGRASP( InsercaoMaisProxima, Busca2Opt, argv[ 1 ], "\n\nInsercao Mais Proxima\n", "2-opt\n" ) ; 
      AnalisarGRASP( InsercaoMaisProxima, Busca2OptTo3Opt, argv[ 1 ], "\n\nInsercao Mais Proxima\n", "2-opt a 3-opt\n" ) ; 

      AnalisarGRASP( InsercaoMaisDistante, Busca2Opt, argv[ 1 ], "\n\nInsercao Mais Distante\n", "2-opt\n" ) ; 
      AnalisarGRASP( InsercaoMaisDistante, Busca2OptTo3Opt, argv[ 1 ], "\n\nInsercao Mais Distante\n", "2-opt a 3-opt\n" ) ;
   
      AnalisarGRASP( InsercaoMaisBarata, Busca2Opt, argv[ 1 ], "\n\nInsercao Mais Barata\n", "2-opt\n" ) ; 
      AnalisarGRASP( InsercaoMaisBarata, Busca2OptTo3Opt, argv[ 1 ], "\n\nInsercao Mais Barata\n", "2-opt a 3-opt\n" ) ; 
   } else {

      int         i                       ;
      tpCusto     CustoMin      = INT_MAX ;
      tpInstancia inst                    ;
      tpNo*       pMemoria[ 4 ]           ;
      char        szMaisEfic[ 100 ]       ;
      time_t      TempoInicial            ,
                  TempoFinal              ;
      double      dTempo                  ;
   
      inst = LerInstancia( argv[ 2 ] ) ;
      printf( "Rota canonica de %s: %d\n", argv[ 2 ], VerificarRotaCanonica( inst->Grafo, inst->NumNos ) ) ;
       
      for ( i = 0 ; i < 4 ; i++ ) {
         pMemoria[ i ] = ( tpNo* )malloc( sizeof( tpNo ) * inst->NumNos ) ;
         if ( pMemoria == NULL ) {
            printf( SZ_ERR_MEM ) ;
            exit( 0 ) ;
         } /* if */  
      } /* for */
    
      TempoInicial = clock( ) ;
      AnalisarConsInst( inst->Grafo, inst->NumNos, VizinhoMaisProximo, "\n\nVizinho Mais Proximo\n", pMemoria, &CustoMin, szMaisEfic ) ;
      AnalisarConsInst( inst->Grafo, inst->NumNos, InsercaoMaisProxima, "\n\nInsercao Mais Proxima\n", pMemoria, &CustoMin, szMaisEfic ) ;
      AnalisarConsInst( inst->Grafo, inst->NumNos, InsercaoMaisDistante, "\n\nInsercao Mais Distante\n", pMemoria, &CustoMin, szMaisEfic ) ;
      AnalisarConsInst( inst->Grafo, inst->NumNos, InsercaoMaisBarata, "\n\nInsercao Mais Barata\n", pMemoria, &CustoMin, szMaisEfic ) ;
      AnalisarGRASPInst( inst->Grafo, inst->NumNos, VizinhoMaisProximo, Busca2Opt, "\n\nVizinho Mais Proximo\n", "2-opt\n", pMemoria, &CustoMin, szMaisEfic ) ;  
      AnalisarGRASPInst( inst->Grafo, inst->NumNos, InsercaoMaisProxima, Busca2Opt, "\n\nInsercao Mais Proxima\n", "2-opt\n", pMemoria, &CustoMin, szMaisEfic ) ;
      AnalisarGRASPInst( inst->Grafo, inst->NumNos, InsercaoMaisDistante, Busca2Opt, "\n\nInsercao Mais Distante\n", "2-opt\n", pMemoria, &CustoMin, szMaisEfic ) ;  
      AnalisarGRASPInst( inst->Grafo, inst->NumNos, InsercaoMaisBarata, Busca2Opt, "\n\nInsercao Mais Barata\n", "2-opt\n", pMemoria, &CustoMin, szMaisEfic ) ; 
      AnalisarGRASPInst( inst->Grafo, inst->NumNos, VizinhoMaisProximo, Busca2OptTo3Opt, "\n\nVizinho Mais Proximo\n", "2-opt a 3-opt\n", pMemoria, &CustoMin, szMaisEfic ) ;  
      AnalisarGRASPInst( inst->Grafo, inst->NumNos, InsercaoMaisProxima, Busca2OptTo3Opt, "\n\nInsercao Mais Proxima\n", "2-opt a 3-opt\n", pMemoria, &CustoMin, szMaisEfic ) ; 
      AnalisarGRASPInst( inst->Grafo, inst->NumNos, InsercaoMaisDistante, Busca2OptTo3Opt, "\n\nInsercao Mais Distante\n", "2-opt a 3-opt\n", pMemoria, &CustoMin, szMaisEfic ) ; 
      AnalisarGRASPInst( inst->Grafo, inst->NumNos, InsercaoMaisBarata, Busca2OptTo3Opt, "\n\nInsercao Mais Barata\n", "2-opt a 3-opt\n", pMemoria, &CustoMin, szMaisEfic ) ;    
      TempoFinal = clock( ) ;
       
      dTempo = ( double )( TempoFinal - TempoInicial ) / CLOCKS_PER_SEC ;
      
      printf( "%s ", szMaisEfic ) ;
      printf( "%d ", CustoMin ) ;
      printf( "%lf ", ( double )CustoMin / atof( argv[ 3 ] ) ) ;
      printf( "%lf ", dTempo ) ;

      for ( i = 0 ; i < 4 ; i++ ) {
         free( pMemoria[ i ] ) ;
      } /* for */
   } /* if */

   return 0 ;

}
